From 88be372782a8665c76ec431a74012ac12380a4e3 Mon Sep 17 00:00:00 2001
From: Gareth Williams <garethw@codeaurora.org>
Date: Mon, 23 Mar 2015 19:51:01 +0000
Subject: [PATCH 14/16] [qca-nss-ecm] En/dis support for tracker DPI features

Enable/disable support for tracker deep-packet-inspection features.
Enabling this allows data tracking and packet inspection facilities.

Change-Id: Ib354baa1ae9c4e4d2be57590b7f3e54e5d7380ea
Signed-off-by: Gareth Williams <garethw@codeaurora.org>
---
 Makefile                 |  7 ++++
 ecm_classifier_default.c | 73 +++++--------------------------------
 ecm_tracker.c            | 20 ++++++++---
 ecm_tracker.h            | 12 +++++--
 ecm_tracker_datagram.c   | 38 +++++++++++++++++---
 ecm_tracker_tcp.c        | 94 +++++++++++++++++++++++++++++++++++++++---------
 ecm_tracker_tcp.h        |  9 +++--
 ecm_tracker_udp.c        | 47 +++++++++++++++++++-----
 ecm_tracker_udp.h        |  6 +++-
 9 files changed, 201 insertions(+), 105 deletions(-)

diff --git a/Makefile b/Makefile
index 5214fbf..31ef7bb 100755
--- a/Makefile
+++ b/Makefile
@@ -137,6 +137,13 @@ ECM_DB_CONNECTION_CROSS_REFERENCING_ENABLE=y
 ccflags-$(ECM_DB_CONNECTION_CROSS_REFERENCING_ENABLE) += -DECM_DB_XREF_ENABLE
 
 # #############################################################################
+# Define ECM_TRACKER_DPI_SUPPORT_ENABLE=y in order to enable support for
+# deep packet inspection and tracking of data with the trackers.
+# #############################################################################
+ECM_TRACKER_DPI_SUPPORT_ENABLE=y
+ccflags-$(ECM_TRACKER_DPI_SUPPORT_ENABLE) += -DECM_TRACKER_DPI_SUPPORT_ENABLE
+
+# #############################################################################
 # Debug flags, set these to = 0 if you want to disable all debugging for that
 # file.
 # By turning off debugs you gain maximum ECM performance.
diff --git a/ecm_classifier_default.c b/ecm_classifier_default.c
index ce3b173..82664a1 100644
--- a/ecm_classifier_default.c
+++ b/ecm_classifier_default.c
@@ -86,6 +86,7 @@ struct ecm_classifier_default_internal_instance {
 	struct ecm_classifier_default_instance base;		/* Base type */
 
 	uint32_t ci_serial;					/* RO: Serial of the connection */
+	int protocol;						/* RO: Protocol of the connection */
 
 	struct ecm_classifier_process_response process_response;
 								/* Last process response computed */
@@ -95,8 +96,7 @@ struct ecm_classifier_default_internal_instance {
 	ecm_tracker_sender_type_t ingress_sender;		/* RO: Which sender is sending ingress data */
 	ecm_tracker_sender_type_t egress_sender;		/* RO: Which sender is sending egress data */
 
-	struct ecm_tracker_instance *ti;			/* RO: Tracker used while we detect MSS. Pointer will not change so safe to access outside of lock. */
-	bool tracking;						/* Are we tracking? */
+	struct ecm_tracker_instance *ti;			/* RO: Tracker used for state and timer group checking. Pointer will not change so safe to access outside of lock. */
 
 	int refs;						/* Integer to trap we never go negative */
 #if (DEBUG_LEVEL > 0)
@@ -219,33 +219,11 @@ static void ecm_classifier_default_process(struct ecm_classifier_instance *aci,
 	ecm_tracker_sender_state_t to_state;
 	ecm_tracker_connection_state_t prevailing_state;
 	ecm_db_timer_group_t tg;
-	struct ecm_tracker_tcp_instance *tti;
-	bool tracking;
 	struct ecm_classifier_default_internal_instance *cdii = (struct ecm_classifier_default_internal_instance *)aci;
 	struct nf_conn *ct;
 	enum ip_conntrack_info ctinfo;
-	struct ecm_db_connection_instance *ci;
-	int protocol;
 	DEBUG_CHECK_MAGIC(cdii, ECM_CLASSIFIER_DEFAULT_INTERNAL_INSTANCE_MAGIC, "%p: invalid state magic\n", cdii);
 
-	/*
-	 * Lookup the associated connection to identify its protocol type.
-	 */
-	ci = ecm_db_connection_serial_find_and_ref(cdii->ci_serial);
-	if (!ci) {
-		DEBUG_TRACE("%p: No ci found for %u\n", cdii, cdii->ci_serial);
-
-		/*
-		 * Still relevant but have no actions that need processing
-		 */
-		spin_lock_bh(&ecm_classifier_default_lock);
-		cdii->process_response.process_actions = 0;
-		*process_response = cdii->process_response;
-		spin_unlock_bh(&ecm_classifier_default_lock);
-		return;
-	}
-	protocol = ecm_db_connection_protocol_get(ci);
-	ecm_db_connection_deref(ci);
 
 	spin_lock_bh(&ecm_classifier_default_lock);
 
@@ -302,7 +280,7 @@ static void ecm_classifier_default_process(struct ecm_classifier_instance *aci,
 	/*
 	 * Handle non-TCP case
 	 */
-	if (protocol != IPPROTO_TCP) {
+	if (cdii->protocol != IPPROTO_TCP) {
 		if (unlikely(prevailing_state != ECM_TRACKER_CONNECTION_STATE_ESTABLISHED)) {
 			cdii->process_response.accel_mode = ECM_CLASSIFIER_ACCELERATION_MODE_NO;
 		}
@@ -310,28 +288,9 @@ static void ecm_classifier_default_process(struct ecm_classifier_instance *aci,
 	}
 
 	/*
-	 * Until the connection is established we track data, only to detect mss
-	 */
-	spin_lock_bh(&ecm_classifier_default_lock);
-	tracking = cdii->tracking;
-	spin_unlock_bh(&ecm_classifier_default_lock);
-	if (tracking) {
-		if (!ti->datagram_add(ti, sender, skb)) {
-			spin_lock_bh(&ecm_classifier_default_lock);
-			cdii->tracking = false;
-			spin_unlock_bh(&ecm_classifier_default_lock);
-		} else {
-			/*
-			 * Discard as we don't actually need it, we just wanted the tracker to detect MSS
-			 */
-			ti->discard_all(ti);
-		}
-	}
-
-	/*
 	 * Check the TCP connection state.
-	 * If we are not established then we deny acceleration but, if tracking,
-	 * continue to track for MSS.
+	 * If we are not established then we deny acceleration.
+	 * Take lead from conntrack if exists.
 	 */
 	ct = nf_ct_get(skb, &ctinfo);
 	if (ct == NULL) {
@@ -365,19 +324,6 @@ static void ecm_classifier_default_process(struct ecm_classifier_instance *aci,
 		spin_unlock_bh(&ct->lock);
 	}
 
-	/*
-	 * The connection is now established.
-	 * There is no longer a need to track for MSS because that is only available at the SYN stages.
-	 */
-	spin_lock_bh(&ecm_classifier_default_lock);
-	cdii->tracking = false;
-	spin_unlock_bh(&ecm_classifier_default_lock);
-
-	/*
-	 * By implication the tracker is a TCP tracker
-	 */
-	tti = (struct ecm_tracker_tcp_instance *)ti;
-
 return_response:
 	;
 
@@ -519,7 +465,6 @@ static int ecm_classifier_default_xml_state_get(struct ecm_classifier_instance *
 	ecm_db_timer_group_t timer_group;
 	ecm_tracker_sender_type_t ingress_sender;
 	ecm_tracker_sender_type_t egress_sender;
-	bool tracking;
 	int count;
 	int total;
 
@@ -527,7 +472,6 @@ static int ecm_classifier_default_xml_state_get(struct ecm_classifier_instance *
 	DEBUG_CHECK_MAGIC(cdii, ECM_CLASSIFIER_DEFAULT_INTERNAL_INSTANCE_MAGIC, "%p: magic failed", cdii);
 
 	spin_lock_bh(&ecm_classifier_default_lock);
-	tracking = cdii->tracking;
 	egress_sender = cdii->egress_sender;
 	ingress_sender = cdii->ingress_sender;
 	timer_group = cdii->timer_group;
@@ -535,11 +479,10 @@ static int ecm_classifier_default_xml_state_get(struct ecm_classifier_instance *
 	spin_unlock_bh(&ecm_classifier_default_lock);
 
 	count = snprintf(buf, buf_sz, "<ecm_classifier_default ingress_sender=\"%d\" egress_sender=\"%d\" "
-			"timer_group=\"%d\" tracking=\"%u\">\n",
+			"timer_group=\"%d\">\n",
 			ingress_sender,
 			egress_sender,
-			timer_group,
-			tracking);
+			timer_group);
 	if ((count <= 0) || (count >= buf_sz)) {
 		return -1;
 	}
@@ -608,7 +551,6 @@ struct ecm_classifier_default_instance *ecm_classifier_default_instance_alloc(st
 			return NULL;
 		}
 		ecm_tracker_tcp_init((struct ecm_tracker_tcp_instance *)cdii->ti, ECM_TRACKER_CONNECTION_TRACKING_LIMIT_DEFAULT, 1500, 1500);
-		cdii->tracking = true;
 	} else if (protocol == IPPROTO_UDP) {
 		DEBUG_TRACE("%p: Alloc tracker for UDP connection: %p\n", cdii, ci);
 		cdii->ti = (struct ecm_tracker_instance *)ecm_tracker_udp_alloc();
@@ -632,6 +574,7 @@ struct ecm_classifier_default_instance *ecm_classifier_default_instance_alloc(st
 	DEBUG_SET_MAGIC(cdii, ECM_CLASSIFIER_DEFAULT_INTERNAL_INSTANCE_MAGIC);
 	cdii->refs = 1;
 	cdii->ci_serial = ecm_db_connection_serial_get(ci);
+	cdii->protocol = protocol;
 
 	/*
 	 * We are always relevant to the connection
diff --git a/ecm_tracker.c b/ecm_tracker.c
index 5c74bd5..4bb8a6d 100644
--- a/ecm_tracker.c
+++ b/ecm_tracker.c
@@ -1,6 +1,6 @@
 /*
  **************************************************************************
- * Copyright (c) 2014, The Linux Foundation.  All rights reserved.
+ * Copyright (c) 2014, 2015, The Linux Foundation.  All rights reserved.
  * Permission to use, copy, modify, and/or distribute this software for
  * any purpose with or without fee is hereby granted, provided that the
  * above copyright notice and this permission notice appear in all copies.
@@ -62,11 +62,13 @@
 #include "ecm_db_types.h"
 #include "ecm_tracker.h"
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 int ecm_tracker_data_total = 0;				/* Data total for all skb list instances */
 int ecm_tracker_data_buffer_total = 0;			/* Data buffer total allocated for all skb list instances */
 int ecm_tracker_data_limit = ECM_TRACKER_GLOBAL_DATA_LIMIT_DEFAULT;
 int ecm_tracker_data_buffer_limit = ECM_TRACKER_GLOBAL_DATA_BUFFER_LIMIT_DEFAULT;
 							/* Tracked limit for data across all instances */
+#endif
 spinlock_t ecm_tracker_lock;				/* Global lock for the tracker globals */
 
 struct ecm_tracker_ip_protocols;
@@ -1003,6 +1005,7 @@ static bool ecm_tracker_ip_header_helper_icmp(struct ecm_tracker_ip_protocols *e
 	return true;
 }
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 /*
  * ecm_tracker_data_limit_set()
  *	Set global tracked data limit
@@ -1100,6 +1103,7 @@ void ecm_tracker_data_total_decrease(uint32_t n, uint32_t data_buffer_size)
 	spin_unlock_bh(&ecm_tracker_lock);
 }
 EXPORT_SYMBOL(ecm_tracker_data_total_decrease);
+#endif
 
 /*
  * ecm_tracker_module_get()
@@ -1121,15 +1125,21 @@ void ecm_tracker_module_put(void)
 }
 EXPORT_SYMBOL(ecm_tracker_module_put);
 
-const char *
-ecm_tracker_sender_state_to_string(enum ecm_tracker_sender_states s)
+/*
+ * ecm_tracker_sender_state_to_string()
+ *	Convert a sender state to a string equivalent
+ */
+const char *ecm_tracker_sender_state_to_string(enum ecm_tracker_sender_states s)
 {
 	return ecm_tracker_sender_state_strings[s];
 }
 EXPORT_SYMBOL(ecm_tracker_sender_state_to_string);
 
-const char *
-ecm_tracker_connection_state_to_string(enum ecm_tracker_connection_states s)
+/*
+ * ecm_tracker_connection_state_to_string()
+ *	Convert a connection state to its string equivalent
+ */
+const char *ecm_tracker_connection_state_to_string(enum ecm_tracker_connection_states s)
 {
 	return ecm_tracker_connection_state_strings[s];
 }
diff --git a/ecm_tracker.h b/ecm_tracker.h
index dcc8dc4..61e819f 100644
--- a/ecm_tracker.h
+++ b/ecm_tracker.h
@@ -150,6 +150,7 @@ struct ecm_tracker_ip_header {
 					/* Use one of the ECM_TRACKER_IP_PROTOCOL_TYPE_XYZ constants to index into this to locate the header you want to inspect.  If the size is zero then the header was not found. */
 };
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 typedef int32_t (*ecm_tracker_datagram_count_get_method_t)(struct ecm_tracker_instance *ti, ecm_tracker_sender_type_t sender);
 													/* Return number of available datagrams sent by the sender */
 typedef void (*ecm_tracker_datagram_discard_method_t)(struct ecm_tracker_instance *ti, ecm_tracker_sender_type_t sender, int32_t n);
@@ -160,9 +161,6 @@ typedef int (*ecm_tracker_datagram_read_method_t)(struct ecm_tracker_instance *t
 													/* Read size bytes from datagram at index i into the buffer */
 typedef bool (*ecm_tracker_datagram_add_method_t)(struct ecm_tracker_instance *ti, ecm_tracker_sender_type_t sender, struct sk_buff *skb);
 													/* Add (append) the datagram into the tracker */
-typedef void (*ecm_tracker_ref_method_t)(struct ecm_tracker_instance *ti);
-typedef int (*ecm_tracker_deref_method_t)(struct ecm_tracker_instance *ti);
-
 typedef void (*ecm_tracker_discard_all_method_t)(struct ecm_tracker_instance *ti);
 													/* Discard all tracked data */
 typedef int32_t (*ecm_tracker_data_total_get_method_t)(struct ecm_tracker_instance *ti);
@@ -171,6 +169,10 @@ typedef int32_t (*ecm_tracker_data_limit_get_method_t)(struct ecm_tracker_instan
 													/* Return the limit on the number of bytes we can track */
 typedef void (*ecm_tracker_data_limit_set_method_t)(struct ecm_tracker_instance *ti, int32_t data_limit);
 													/* Set the limit on the number of bytes we can track */
+#endif
+typedef void (*ecm_tracker_ref_method_t)(struct ecm_tracker_instance *ti);
+typedef int (*ecm_tracker_deref_method_t)(struct ecm_tracker_instance *ti);
+
 typedef void (*ecm_tracker_state_update_method_t)(struct ecm_tracker_instance *ti, ecm_tracker_sender_type_t sender, struct ecm_tracker_ip_header *ip_hdr, struct sk_buff *skb);
 													/* Update state of the sender */
 typedef void (*ecm_tracker_state_get_method_t)(struct ecm_tracker_instance *ti, ecm_tracker_sender_state_t *src_state, ecm_tracker_sender_state_t *dest_state, ecm_tracker_connection_state_t *state, ecm_db_timer_group_t *tg);
@@ -191,6 +193,7 @@ typedef int (*ecm_tracker_xml_state_get_callback_t)(struct ecm_tracker_instance
  * ALL trackers must be castable to a type of this, i.e. this structure must be the first element of their own data type.
  */
 struct ecm_tracker_instance {
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 	ecm_tracker_data_total_get_method_t data_total_get;
 	ecm_tracker_data_limit_get_method_t data_limit_get;
 	ecm_tracker_data_limit_set_method_t data_limit_set;
@@ -200,6 +203,7 @@ struct ecm_tracker_instance {
 	ecm_tracker_datagram_read_method_t datagram_read;
 	ecm_tracker_datagram_add_method_t datagram_add;
 	ecm_tracker_discard_all_method_t discard_all;
+#endif
 	ecm_tracker_state_update_method_t state_update;
 	ecm_tracker_state_get_method_t state_get;
 #ifdef ECM_STATE_OUTPUT_ENABLE
@@ -210,10 +214,12 @@ struct ecm_tracker_instance {
 };
 
 bool ecm_tracker_ip_check_header_and_read(struct ecm_tracker_ip_header *ip_hdr, struct sk_buff *skb);
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 uint32_t ecm_tracker_data_limit_get(void);
 void ecm_tracker_data_limit_set(uint32_t limit);
 uint32_t ecm_tracker_data_total_get(void);
 uint32_t ecm_tracker_data_buffer_total_get(void);
 bool ecm_tracker_data_total_increase(uint32_t n, uint32_t data_bufer_size);
 void ecm_tracker_data_total_decrease(uint32_t n, uint32_t data_bufer_size);
+#endif
 
diff --git a/ecm_tracker_datagram.c b/ecm_tracker_datagram.c
index ce5fbf1..15d7380 100644
--- a/ecm_tracker_datagram.c
+++ b/ecm_tracker_datagram.c
@@ -74,6 +74,7 @@
 struct ecm_tracker_datagram_internal_instance {
 	struct ecm_tracker_datagram_instance datagram_base;	/* MUST BE FIRST FIELD */
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 	/*
 	 * skb-next and skb->prev pointers are leveraged for these lists
 	 */
@@ -88,6 +89,7 @@ struct ecm_tracker_datagram_internal_instance {
 	int32_t dest_bytes_total;		/* Total bytes in all received datagrams */
 
 	int32_t data_limit;			/* Limit for tracked data */
+#endif
 
 	ecm_tracker_sender_state_t sender_state[ECM_TRACKER_SENDER_MAX];
 						/* State of each sender */
@@ -117,6 +119,7 @@ static ecm_tracker_connection_state_t ecm_tracker_datagram_connection_state_matr
 	/* Fault */		{ECM_TRACKER_CONNECTION_STATE_FAULT,		ECM_TRACKER_CONNECTION_STATE_FAULT,		ECM_TRACKER_CONNECTION_STATE_FAULT,		ECM_TRACKER_CONNECTION_STATE_FAULT,	ECM_TRACKER_CONNECTION_STATE_FAULT,	ECM_TRACKER_CONNECTION_STATE_FAULT},
 };
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 /*
  * ecm_tracker_datagram_datagram_discard()
  *	Discard n number of datagrams at the head of the datagram list that were sent to the target
@@ -229,6 +232,7 @@ static void ecm_tracker_datagram_discard_all_callback(struct ecm_tracker_instanc
 	struct ecm_tracker_datagram_internal_instance *dtii = (struct ecm_tracker_datagram_internal_instance *)ti;
 	ecm_tracker_datagram_discard_all(dtii);
 }
+#endif
 
 /*
  * ecm_tracker_datagram_ref()
@@ -279,11 +283,13 @@ static int ecm_tracker_datagram_deref(struct ecm_tracker_datagram_internal_insta
 
 	DEBUG_TRACE("%p: final\n", dtii);
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 	/*
 	 * Destroy all datagrams
 	 */
 	ecm_tracker_datagram_datagram_discard(dtii, ECM_TRACKER_SENDER_TYPE_SRC, dtii->src_count);
 	ecm_tracker_datagram_datagram_discard(dtii, ECM_TRACKER_SENDER_TYPE_DEST, dtii->dest_count);
+#endif
 
 	spin_lock_bh(&ecm_tracker_datagram_lock);
 	ecm_tracker_datagram_count--;
@@ -306,6 +312,7 @@ static int ecm_tracker_datagram_deref_callback(struct ecm_tracker_instance *ti)
 	return ecm_tracker_datagram_deref(dtii);
 }
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 /*
  * ecm_tracker_datagram_datagram_count_get()
  *	Return number of available datagrams sent to the specified target
@@ -596,6 +603,7 @@ static void ecm_tracker_datagram_data_limit_set_callback(struct ecm_tracker_inst
 	dtii->data_limit = data_limit;
 	spin_unlock_bh(&dtii->lock);
 }
+#endif
 
 /*
  * ecm_tracker_datagram_state_update_callback()
@@ -639,11 +647,13 @@ static void ecm_tracker_datagram_state_get_callback(struct ecm_tracker_instance
 static int ecm_tracker_datagram_xml_state_get_callback(struct ecm_tracker_instance *ti, char *buf, int buf_sz)
 {
 	struct ecm_tracker_datagram_internal_instance *dtii = (struct ecm_tracker_datagram_internal_instance *)ti;
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 	int32_t src_count;
 	int32_t src_bytes_total;
 	int32_t dest_count;
 	int32_t dest_bytes_total;
 	int32_t data_limit;
+#endif
 	ecm_tracker_sender_state_t sender_state[ECM_TRACKER_SENDER_MAX];
 	ecm_tracker_connection_state_t connection_state;
 	DEBUG_CHECK_MAGIC(dtii, ECM_TRACKER_DATAGRAM_INSTANCE_MAGIC, "%p: magic failed", dtii);
@@ -652,24 +662,38 @@ static int ecm_tracker_datagram_xml_state_get_callback(struct ecm_tracker_instan
 	 * Capture state
 	 */
 	spin_lock_bh(&dtii->lock);
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 	src_count = dtii->src_count;
 	src_bytes_total = dtii->src_bytes_total;
 	dest_count = dtii->dest_count;
 	dest_bytes_total = dtii->dest_bytes_total;
 	data_limit = dtii->data_limit;
+#endif
 	sender_state[ECM_TRACKER_SENDER_TYPE_SRC] = dtii->sender_state[ECM_TRACKER_SENDER_TYPE_SRC];
 	sender_state[ECM_TRACKER_SENDER_TYPE_DEST] = dtii->sender_state[ECM_TRACKER_SENDER_TYPE_DEST];
 	spin_unlock_bh(&dtii->lock);
 	connection_state = ecm_tracker_datagram_connection_state_matrix[sender_state[ECM_TRACKER_SENDER_TYPE_SRC]][sender_state[ECM_TRACKER_SENDER_TYPE_DEST]];
 
-	return snprintf(buf, buf_sz, "<datagram_tracker src_count=\"%d\" src_bytes_total=\"%d\" "
-			"dest_count=\"%d\" dest_bytes_total=\"%d\" data_limit=\"%d\" timer_group=\"%d\""
-			" src_sender_state=\"%s\" dest_sender_state=\"%s\" connection_state=\"%s\"/>\n",
+	return snprintf(buf, buf_sz, "<datagram_tracker"
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
+			" src_count=\"%d\""
+			" src_bytes_total=\"%d\""
+			" dest_count=\"%d\""
+			" dest_bytes_total=\"%d\""
+			" data_limit=\"%d\""
+#endif
+			" timer_group=\"%d\""
+			" src_sender_state=\"%s\""
+			" dest_sender_state=\"%s\""
+			" connection_state=\"%s\""
+			"/>\n",
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 			src_count,
 			src_bytes_total,
 			dest_count,
 			dest_bytes_total,
 			data_limit,
+#endif
 			ECM_DB_TIMER_GROUPS_CONNECTION_GENERIC_TIMEOUT,
 			ecm_tracker_sender_state_to_string(sender_state[ECM_TRACKER_SENDER_TYPE_SRC]),
 			ecm_tracker_sender_state_to_string(sender_state[ECM_TRACKER_SENDER_TYPE_DEST]),
@@ -687,9 +711,11 @@ void ecm_tracker_datagram_init(struct ecm_tracker_datagram_instance *uti, int32_
 	DEBUG_CHECK_MAGIC(dtii, ECM_TRACKER_DATAGRAM_INSTANCE_MAGIC, "%p: magic failed", dtii);
 	DEBUG_TRACE("%p: init tracker\n", uti);
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 	spin_lock_bh(&dtii->lock);
 	dtii->data_limit = data_limit;
 	spin_unlock_bh(&dtii->lock);
+#endif
 }
 EXPORT_SYMBOL(ecm_tracker_datagram_init);
 
@@ -708,6 +734,9 @@ struct ecm_tracker_datagram_instance *ecm_tracker_datagram_alloc(void)
 
 	dtii->datagram_base.base.ref = ecm_tracker_datagram_ref_callback;
 	dtii->datagram_base.base.deref = ecm_tracker_datagram_deref_callback;
+	dtii->datagram_base.base.state_update = ecm_tracker_datagram_state_update_callback;
+	dtii->datagram_base.base.state_get = ecm_tracker_datagram_state_get_callback;
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 	dtii->datagram_base.base.datagram_count_get = ecm_tracker_datagram_datagram_count_get_callback;
 	dtii->datagram_base.base.datagram_discard = ecm_tracker_datagram_datagram_discard_callback;
 	dtii->datagram_base.base.datagram_read = ecm_tracker_datagram_datagram_read_callback;
@@ -717,8 +746,7 @@ struct ecm_tracker_datagram_instance *ecm_tracker_datagram_alloc(void)
 	dtii->datagram_base.base.data_total_get = ecm_tracker_datagram_data_total_get_callback;
 	dtii->datagram_base.base.data_limit_get = ecm_tracker_datagram_data_limit_get_callback;
 	dtii->datagram_base.base.data_limit_set = ecm_tracker_datagram_data_limit_set_callback;
-	dtii->datagram_base.base.state_update = ecm_tracker_datagram_state_update_callback;
-	dtii->datagram_base.base.state_get = ecm_tracker_datagram_state_get_callback;
+#endif
 #ifdef ECM_STATE_OUTPUT_ENABLE
 	dtii->datagram_base.base.xml_state_get = ecm_tracker_datagram_xml_state_get_callback;
 #endif
diff --git a/ecm_tracker_tcp.c b/ecm_tracker_tcp.c
index 6b89e0c..a2b27ad 100644
--- a/ecm_tracker_tcp.c
+++ b/ecm_tracker_tcp.c
@@ -107,6 +107,7 @@ static uint32_t ecm_tracker_tcp_valid_flags[ECM_TRACKER_TCP_VALID_FLAGS_MAX] = {
 #define ECM_TRACKER_TCP_SKB_CB_MAGIC 0x4398
 #define ECM_TRACKER_TCP_READER_INSTANCE_MAGIC 0x1123
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 /*
  * struct ecm_tracker_tcp_skb_cb_format
  *	Map of the cb[] array within our cached buffers - we use that area for our tracking
@@ -122,7 +123,6 @@ struct ecm_tracker_tcp_skb_cb_format {
 #endif
 };
 
-
 /*
  * struct ecm_tracker_tcp_host_data
  *	data tracking for a host
@@ -161,6 +161,7 @@ struct ecm_tracker_tcp_host_data {
 							 */
 
 };
+#endif
 
 /*
  * struct ecm_tracker_tcp_sender_state
@@ -177,9 +178,13 @@ struct ecm_tracker_tcp_sender_state {
  */
 struct ecm_tracker_tcp_internal_instance  {
 	struct ecm_tracker_tcp_instance tcp_base;					/* MUST BE FIRST FIELD */
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 	struct ecm_tracker_tcp_host_data sender_data[ECM_TRACKER_SENDER_MAX];		/* Data tracked sent by the src of the connection */
+#endif
 	struct ecm_tracker_tcp_sender_state sender_states[ECM_TRACKER_SENDER_MAX];	/* Sender states */
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 	int32_t data_limit;								/* Limit for tracked data */
+#endif
 	int refs;									/* Integer to trap we never go negative */
 	spinlock_t lock;
 #if (DEBUG_LEVEL > 0)
@@ -187,6 +192,7 @@ struct ecm_tracker_tcp_internal_instance  {
 #endif
 };
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 /*
  * struct ecm_tracker_tcp_reader_instance
  *	Reader.
@@ -222,6 +228,7 @@ struct ecm_tracker_tcp_reader_instance {
 	uint16_t magic;
 #endif
 };
+#endif
 
 /*
  * ecm_tracker_tcp_timer_group_from_state[]
@@ -238,7 +245,9 @@ static ecm_db_timer_group_t ecm_tracker_tcp_timer_group_from_state[] = {
 							ECM_DB_TIMER_GROUPS_CONNECTION_TCP_RESET_TIMEOUT,	/* ECM_TRACKER_CONNECTION_STATE_FAULT */
 							};
 int ecm_tracker_tcp_count = 0;		/* Counts the number of TCP data trackers right now */
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 int ecm_tracker_tcp_reader_count = 0;	/* Counts the number of TCP readers right now */
+#endif
 spinlock_t ecm_tracker_tcp_lock;	/* Global lock for the tracker globals */
 
 /*
@@ -311,6 +320,7 @@ struct tcphdr *ecm_tracker_tcp_check_header_and_read(struct sk_buff *skb, struct
 }
 EXPORT_SYMBOL(ecm_tracker_tcp_check_header_and_read);
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 /*
  * ecm_tracker_tcp_bytes_discard()
  *	Discard n bytes from the available in_order bytes
@@ -556,6 +566,7 @@ static void ecm_tracker_tcp_discard_all_callback(struct ecm_tracker_instance *ti
 	_ecm_tracker_tcp_discard_all(ttii);
 	spin_unlock_bh(&ttii->lock);
 }
+#endif
 
 /*
  * ecm_tracker_tcp_ref_callback()
@@ -595,7 +606,9 @@ int ecm_tracker_tcp_deref_callback(struct ecm_tracker_instance *ti)
 	}
 
 	DEBUG_TRACE("%p: final\n", ttii);
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 	_ecm_tracker_tcp_discard_all(ttii);
+#endif
 	spin_unlock_bh(&ttii->lock);
 
 	spin_lock_bh(&ecm_tracker_tcp_lock);
@@ -610,6 +623,7 @@ int ecm_tracker_tcp_deref_callback(struct ecm_tracker_instance *ti)
 	return 0;
 }
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 /*
  * ecm_tracker_tcp_datagram_count_get_callback()
  *	Return number of available datagrams sent to the specified target in the in_order list
@@ -1653,6 +1667,7 @@ static void ecm_tracker_tcp_data_limit_set_callback(struct ecm_tracker_instance
 	ttii->data_limit = data_limit;
 	spin_unlock_bh(&ttii->lock);
 }
+#endif
 
 /*
  * ecm_tracker_tcp_state_update_callback()
@@ -1891,12 +1906,28 @@ static void ecm_tracker_tcp_state_get_callback(struct ecm_tracker_instance *ti,
  * ecm_tracker_tcp_sender_xml_state_get()
  *	Return an XML state element
  */
-static int ecm_tracker_tcp_sender_xml_state_get(char *buf, int buf_sz, ecm_tracker_sender_type_t sender, struct ecm_tracker_tcp_host_data *data, struct ecm_tracker_tcp_sender_state *state)
+static int ecm_tracker_tcp_sender_xml_state_get(char *buf, int buf_sz, ecm_tracker_sender_type_t sender,
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
+						struct ecm_tracker_tcp_host_data *data,
+#endif
+						struct ecm_tracker_tcp_sender_state *state)
 {
-	return snprintf(buf, buf_sz, "<sender_%s mss_seen=\"%s\" mss=\"%u\" "
-			"seq_no=\"%u\" num_seqs=\"%u\" seq_valid=\"%s\" bytes_total=\"%d\""
-			" buffers_total=\"%d\" state=\"%s\" syn_seq=\"%u\" fin_seq=\"%u\"/>\n",
+	return snprintf(buf, buf_sz, "<sender_%s"
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
+			" mss_seen=\"%s\""
+			" mss=\"%u\""
+			" seq_no=\"%u\""
+			" num_seqs=\"%u\""
+			" seq_valid=\"%s\""
+			" bytes_total=\"%d\""
+			" buffers_total=\"%d\""
+#endif
+			" state=\"%s\""
+			" syn_seq=\"%u\""
+			" fin_seq=\"%u\""
+			"/>\n",
 			(sender == ECM_TRACKER_SENDER_TYPE_SRC)? "src" : "dest",
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 			(data->mss_seen)? "yes" : "no",
 			data->mss,
 			data->seq_no,
@@ -1904,6 +1935,7 @@ static int ecm_tracker_tcp_sender_xml_state_get(char *buf, int buf_sz, ecm_track
 			(data->seq_no_valid)? "yes" : "no",
 			data->recvd_bytes_total,
 			data->recvd_count,
+#endif
 			ecm_tracker_sender_state_to_string(state->state),
 			state->syn_seq,
 			state->fin_seq);
@@ -1918,9 +1950,11 @@ static int ecm_tracker_tcp_xml_state_get_callback(struct ecm_tracker_instance *t
 	struct ecm_tracker_tcp_internal_instance *ttii = (struct ecm_tracker_tcp_internal_instance *)ti;
 	int count;
 	int total;
-	struct ecm_tracker_tcp_host_data sender_data[ECM_TRACKER_SENDER_MAX];
 	struct ecm_tracker_tcp_sender_state sender_states[ECM_TRACKER_SENDER_MAX];
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
+	struct ecm_tracker_tcp_host_data sender_data[ECM_TRACKER_SENDER_MAX];
 	int32_t data_limit;
+#endif
 	ecm_tracker_connection_state_t connection_state;
 	DEBUG_CHECK_MAGIC(ttii, ECM_TRACKER_TCP_INSTANCE_MAGIC, "%p: magic failed", ttii);
 
@@ -1928,9 +1962,11 @@ static int ecm_tracker_tcp_xml_state_get_callback(struct ecm_tracker_instance *t
 	 * Capture state
 	 */
 	spin_lock_bh(&ttii->lock);
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 	data_limit = ttii->data_limit;
 	sender_data[ECM_TRACKER_SENDER_TYPE_SRC] = ttii->sender_data[ECM_TRACKER_SENDER_TYPE_SRC];
 	sender_data[ECM_TRACKER_SENDER_TYPE_DEST] = ttii->sender_data[ECM_TRACKER_SENDER_TYPE_DEST];
+#endif
 	sender_states[ECM_TRACKER_SENDER_TYPE_SRC] = ttii->sender_states[ECM_TRACKER_SENDER_TYPE_SRC];
 	sender_states[ECM_TRACKER_SENDER_TYPE_DEST] = ttii->sender_states[ECM_TRACKER_SENDER_TYPE_DEST];
 	spin_unlock_bh(&ttii->lock);
@@ -1939,9 +1975,17 @@ static int ecm_tracker_tcp_xml_state_get_callback(struct ecm_tracker_instance *t
 	/*
 	 * Output our opening element
 	 */
-	count = snprintf(buf, buf_sz, "<tcp_tracker connection_state=\"%s\" data_limit=\"%d\">",
-			ecm_tracker_connection_state_to_string(connection_state),
-			data_limit);
+	count = snprintf(buf, buf_sz, "<tcp_tracker"
+			" connection_state=\"%s\""
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
+			" data_limit=\"%d\""
+#endif
+			">",
+			ecm_tracker_connection_state_to_string(connection_state)
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
+			, data_limit
+#endif
+			);
 	if ((count <= 0) || (count >= buf_sz)) {
 		return -1;
 	}
@@ -1951,7 +1995,13 @@ static int ecm_tracker_tcp_xml_state_get_callback(struct ecm_tracker_instance *t
 	/*
 	 * Output src sender
 	 */
-	count = ecm_tracker_tcp_sender_xml_state_get(buf + total, buf_sz, ECM_TRACKER_SENDER_TYPE_SRC, &sender_data[ECM_TRACKER_SENDER_TYPE_SRC], &sender_states[ECM_TRACKER_SENDER_TYPE_SRC]);
+	count = ecm_tracker_tcp_sender_xml_state_get(buf + total,
+			buf_sz,
+			ECM_TRACKER_SENDER_TYPE_SRC,
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
+			&sender_data[ECM_TRACKER_SENDER_TYPE_SRC],
+#endif
+			&sender_states[ECM_TRACKER_SENDER_TYPE_SRC]);
 	if ((count <= 0) || (count >= buf_sz)) {
 		return -1;
 	}
@@ -1961,7 +2011,13 @@ static int ecm_tracker_tcp_xml_state_get_callback(struct ecm_tracker_instance *t
 	/*
 	 * Output dest sender
 	 */
-	count = ecm_tracker_tcp_sender_xml_state_get(buf + total, buf_sz, ECM_TRACKER_SENDER_TYPE_DEST, &sender_data[ECM_TRACKER_SENDER_TYPE_DEST], &sender_states[ECM_TRACKER_SENDER_TYPE_DEST]);
+	count = ecm_tracker_tcp_sender_xml_state_get(buf + total,
+			buf_sz,
+			ECM_TRACKER_SENDER_TYPE_DEST,
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
+			&sender_data[ECM_TRACKER_SENDER_TYPE_DEST],
+#endif
+			&sender_states[ECM_TRACKER_SENDER_TYPE_DEST]);
 	if ((count <= 0) || (count >= buf_sz)) {
 		return -1;
 	}
@@ -1989,11 +2045,13 @@ void ecm_tracker_tcp_init(struct ecm_tracker_tcp_instance *tti, int32_t data_lim
 	struct ecm_tracker_tcp_internal_instance *ttii = (struct ecm_tracker_tcp_internal_instance *)tti;
 	DEBUG_CHECK_MAGIC(ttii, ECM_TRACKER_TCP_INSTANCE_MAGIC, "%p: magic failed", ttii);
 	DEBUG_TRACE("%p: init host addresses src mss: %d, dest mss: %d\n", ttii, mss_src_default, mss_dest_default);
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 	spin_lock_bh(&ttii->lock);
 	ttii->data_limit = data_limit;
 	ttii->sender_data[ECM_TRACKER_SENDER_TYPE_SRC].mss = mss_src_default;
 	ttii->sender_data[ECM_TRACKER_SENDER_TYPE_DEST].mss = mss_dest_default;
 	spin_unlock_bh(&ttii->lock);
+#endif
 }
 EXPORT_SYMBOL(ecm_tracker_tcp_init);
 
@@ -2012,6 +2070,9 @@ struct ecm_tracker_tcp_instance *ecm_tracker_tcp_alloc(void)
 
 	ttii->tcp_base.base.ref = ecm_tracker_tcp_ref_callback;
 	ttii->tcp_base.base.deref = ecm_tracker_tcp_deref_callback;
+	ttii->tcp_base.base.state_update = ecm_tracker_tcp_state_update_callback;
+	ttii->tcp_base.base.state_get = ecm_tracker_tcp_state_get_callback;
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 	ttii->tcp_base.base.datagram_count_get = ecm_tracker_tcp_datagram_count_get_callback;
 	ttii->tcp_base.base.datagram_discard = ecm_tracker_tcp_datagram_discard_callback;
 	ttii->tcp_base.base.datagram_read = ecm_tracker_tcp_datagram_read_callback;
@@ -2021,17 +2082,16 @@ struct ecm_tracker_tcp_instance *ecm_tracker_tcp_alloc(void)
 	ttii->tcp_base.base.data_total_get = ecm_tracker_tcp_data_total_get_callback;
 	ttii->tcp_base.base.data_limit_get = ecm_tracker_tcp_data_limit_get_callback;
 	ttii->tcp_base.base.data_limit_set = ecm_tracker_tcp_data_limit_set_callback;
-	ttii->tcp_base.base.state_update = ecm_tracker_tcp_state_update_callback;
-	ttii->tcp_base.base.state_get = ecm_tracker_tcp_state_get_callback;
-#ifdef ECM_STATE_OUTPUT_ENABLE
-	ttii->tcp_base.base.xml_state_get = ecm_tracker_tcp_xml_state_get_callback;
-#endif
 
 	ttii->tcp_base.bytes_avail_get = ecm_tracker_tcp_bytes_avail_get_callback;
 	ttii->tcp_base.bytes_read = ecm_tracker_tcp_bytes_read_callback;
 	ttii->tcp_base.bytes_discard = ecm_tracker_tcp_bytes_discard_callback;
 	ttii->tcp_base.mss_get = ecm_tracker_tcp_mss_get_callback;
 	ttii->tcp_base.segment_add = ecm_tracker_tcp_segment_add_callback;
+#endif
+#ifdef ECM_STATE_OUTPUT_ENABLE
+	ttii->tcp_base.base.xml_state_get = ecm_tracker_tcp_xml_state_get_callback;
+#endif
 
 	spin_lock_init(&ttii->lock);
 
@@ -2048,6 +2108,7 @@ struct ecm_tracker_tcp_instance *ecm_tracker_tcp_alloc(void)
 }
 EXPORT_SYMBOL(ecm_tracker_tcp_alloc);
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 /*
  * ecm_tracker_tcp_reader_fwd_read_u8()
  *	Read a byte, advancing the read position
@@ -2467,6 +2528,7 @@ struct ecm_tracker_tcp_reader_instance *ecm_tracker_tcp_reader_alloc(void)
 	return tri;
 }
 EXPORT_SYMBOL(ecm_tracker_tcp_reader_alloc);
+#endif
 
 /*
  * ecm_tracker_tcp_module_init()
diff --git a/ecm_tracker_tcp.h b/ecm_tracker_tcp.h
index 76501ee..a689f12 100644
--- a/ecm_tracker_tcp.h
+++ b/ecm_tracker_tcp.h
@@ -1,6 +1,6 @@
 /*
  **************************************************************************
- * Copyright (c) 2014, The Linux Foundation.  All rights reserved.
+ * Copyright (c) 2014, 2015, The Linux Foundation.  All rights reserved.
  * Permission to use, copy, modify, and/or distribute this software for
  * any purpose with or without fee is hereby granted, provided that the
  * above copyright notice and this permission notice appear in all copies.
@@ -16,6 +16,7 @@
 
 struct ecm_tracker_tcp_instance;
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 typedef uint32_t (*ecm_tracker_tcp_bytes_avail_get_method_t)(struct ecm_tracker_tcp_instance *tti, ecm_tracker_sender_type_t sender);
 									/* Return number of bytes available to read */
 typedef int (*ecm_tracker_tcp_bytes_read_method_t)(struct ecm_tracker_tcp_instance *tti, ecm_tracker_sender_type_t sender, uint32_t offset, uint32_t size, void *buffer);
@@ -27,16 +28,18 @@ typedef bool (*ecm_tracker_tcp_mss_get_method_t)(struct ecm_tracker_tcp_instance
 typedef bool (*ecm_tracker_tcp_segment_add_method_t)(struct ecm_tracker_tcp_instance *tti, ecm_tracker_sender_type_t sender,
 								struct ecm_tracker_ip_header *ip_hdr, struct ecm_tracker_ip_protocol_header *ecm_tcp_header, struct tcphdr *tcp_hdr, struct sk_buff *skb);
 									/* Add a pre-checked segment */
-
+#endif
 
 struct ecm_tracker_tcp_instance {
 	struct ecm_tracker_instance base;				/* MUST BE FIRST FIELD */
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 	ecm_tracker_tcp_bytes_avail_get_method_t bytes_avail_get;	/* Return number of bytes available to read */
 	ecm_tracker_tcp_bytes_read_method_t bytes_read;			/* Read a number of bytes */
 	ecm_tracker_tcp_bytes_discard_method_t bytes_discard;		/* Discard n number of bytes from the beginning of the stream */
 	ecm_tracker_tcp_mss_get_method_t mss_get;			/* Get the MSS as sent BY the given target i.e. the maximum number of */
 	ecm_tracker_tcp_segment_add_method_t segment_add;		/* Add a prechecked MSS segment */
+#endif
 };
 
 /*
@@ -47,6 +50,7 @@ struct tcphdr *ecm_tracker_tcp_check_header_and_read(struct sk_buff *skb, struct
 void ecm_tracker_tcp_init(struct ecm_tracker_tcp_instance *tti, int32_t data_limit, uint16_t src_mss_default, uint16_t dest_mss_default);
 struct ecm_tracker_tcp_instance *ecm_tracker_tcp_alloc(void);
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 /*
  * TCP Reader
  *	Faster reading of a stream of bytes.
@@ -68,4 +72,5 @@ struct ecm_tracker_tcp_reader_instance *ecm_tracker_tcp_reader_alloc(void);
 uint32_t ecm_tracker_tcp_reader_remain_get(struct ecm_tracker_tcp_reader_instance *tri);
 uint32_t ecm_tracker_tcp_reader_position_get(struct ecm_tracker_tcp_reader_instance *tri);
 void ecm_tracker_tcp_reader_retreat(struct ecm_tracker_tcp_reader_instance *tri, uint32_t retreatment);
+#endif
 
diff --git a/ecm_tracker_udp.c b/ecm_tracker_udp.c
index e2bb016..cebed15 100644
--- a/ecm_tracker_udp.c
+++ b/ecm_tracker_udp.c
@@ -74,6 +74,7 @@
  */
 #define ECM_TRACKER_UDP_HEADER_SIZE 8		/* UDP header is always 8 bytes RFC 768 Page 1 */
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 /*
  * struct ecm_tracker_udp_skb_cb_format
  *	Map of the cb[] array within our cached buffers - we use that area for our tracking
@@ -85,6 +86,7 @@ struct ecm_tracker_udp_skb_cb_format {
 	uint16_t magic;
 #endif
 };
+#endif
 
 /*
  * struct ecm_tracker_udp_internal_instance
@@ -92,6 +94,7 @@ struct ecm_tracker_udp_skb_cb_format {
 struct ecm_tracker_udp_internal_instance {
 	struct ecm_tracker_udp_instance udp_base;			/* MUST BE FIRST FIELD */
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 	/*
 	 * skb-next and skb->prev pointers are leveraged for these lists
 	 */
@@ -106,6 +109,7 @@ struct ecm_tracker_udp_internal_instance {
 	int32_t dest_bytes_total;		/* Total bytes in all received datagrams */
 
 	int32_t data_limit;			/* Limit for tracked data */
+#endif
 
 	ecm_tracker_sender_state_t sender_state[ECM_TRACKER_SENDER_MAX];
 						/* State of each sender */
@@ -157,6 +161,7 @@ struct udphdr *ecm_tracker_udp_check_header_and_read(struct sk_buff *skb, struct
 }
 EXPORT_SYMBOL(ecm_tracker_udp_check_header_and_read);
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 /*
  * ecm_tracker_udp_datagram_discard()
  *	Discard n number of datagrams at the head of the datagram list that were sent to the target
@@ -261,6 +266,7 @@ static void ecm_tracker_udp_discard_all_callback(struct ecm_tracker_instance *ti
 	struct ecm_tracker_udp_internal_instance *utii = (struct ecm_tracker_udp_internal_instance *)ti;
 	ecm_tracker_udp_discard_all(utii);
 }
+#endif
 
 /*
  * ecm_tracker_udp_ref()
@@ -309,11 +315,13 @@ static int ecm_tracker_udp_deref(struct ecm_tracker_udp_internal_instance *utii)
 
 	DEBUG_TRACE("%p: final\n", utii);
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 	/*
 	 * Destroy all datagrams
 	 */
 	ecm_tracker_udp_datagram_discard(utii, ECM_TRACKER_SENDER_TYPE_SRC, utii->src_count);
 	ecm_tracker_udp_datagram_discard(utii, ECM_TRACKER_SENDER_TYPE_DEST, utii->dest_count);
+#endif
 
 	spin_lock_bh(&ecm_tracker_udp_lock);
 	ecm_tracker_udp_count--;
@@ -336,6 +344,7 @@ int ecm_tracker_udp_deref_callback(struct ecm_tracker_instance *ti)
 	return ecm_tracker_udp_deref(utii);
 }
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 /*
  * ecm_tracker_udp_datagram_count_get()
  *	Return number of available datagrams sent to the specified target
@@ -777,6 +786,7 @@ static int32_t ecm_tracker_udp_data_size_get_callback(struct ecm_tracker_udp_ins
 
 	return size;
 }
+#endif
 
 /*
  * ecm_tracker_udp_state_update_callback()
@@ -820,11 +830,13 @@ static void ecm_tracker_udp_state_get_callback(struct ecm_tracker_instance *ti,
 static int ecm_tracker_udp_xml_state_get_callback(struct ecm_tracker_instance *ti, char *buf, int buf_sz)
 {
 	struct ecm_tracker_udp_internal_instance *utii = (struct ecm_tracker_udp_internal_instance *)ti;
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 	int32_t src_count;
 	int32_t src_bytes_total;
 	int32_t dest_count;
 	int32_t dest_bytes_total;
 	int32_t data_limit;
+#endif
 	ecm_db_timer_group_t timer_group;
 	ecm_tracker_sender_state_t sender_state[ECM_TRACKER_SENDER_MAX];
 	ecm_tracker_connection_state_t connection_state;
@@ -834,25 +846,40 @@ static int ecm_tracker_udp_xml_state_get_callback(struct ecm_tracker_instance *t
 	 * Capture state
 	 */
 	spin_lock_bh(&utii->lock);
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 	src_count = utii->src_count;
 	src_bytes_total = utii->src_bytes_total;
 	dest_count = utii->dest_count;
 	dest_bytes_total = utii->dest_bytes_total;
 	data_limit = utii->data_limit;
+#endif
 	sender_state[ECM_TRACKER_SENDER_TYPE_SRC] = utii->sender_state[ECM_TRACKER_SENDER_TYPE_SRC];
 	sender_state[ECM_TRACKER_SENDER_TYPE_DEST] = utii->sender_state[ECM_TRACKER_SENDER_TYPE_DEST];
 	timer_group = utii->timer_group;
 	spin_unlock_bh(&utii->lock);
 	connection_state = ecm_tracker_udp_connection_state_matrix[sender_state[ECM_TRACKER_SENDER_TYPE_SRC]][sender_state[ECM_TRACKER_SENDER_TYPE_DEST]];
 
-	return snprintf(buf, buf_sz, "<udp_tracker src_count=\"%d\" src_bytes_total=\"%d\" "
-			"dest_count=\"%d\" dest_bytes_total=\"%d\" data_limit=\"%d\" timer_group=\"%d\""
-			" src_sender_state=\"%s\" dest_sender_state=\"%s\" connection_state=\"%s\"/>\n",
+	return snprintf(buf, buf_sz,
+			"<udp_tracker"
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
+			" src_count=\"%d\""
+			" src_bytes_total=\"%d\""
+			" dest_count=\"%d\""
+			" dest_bytes_total=\"%d\""
+			" data_limit=\"%d\""
+#endif
+			" timer_group=\"%d\""
+			" src_sender_state=\"%s\""
+			" dest_sender_state=\"%s\""
+			" connection_state=\"%s\""
+			"/>\n",
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 			src_count,
 			src_bytes_total,
 			dest_count,
 			dest_bytes_total,
 			data_limit,
+#endif
 			timer_group,
 			ecm_tracker_sender_state_to_string(sender_state[ECM_TRACKER_SENDER_TYPE_SRC]),
 			ecm_tracker_sender_state_to_string(sender_state[ECM_TRACKER_SENDER_TYPE_DEST]),
@@ -871,7 +898,9 @@ void ecm_tracker_udp_init(struct ecm_tracker_udp_instance *uti, int32_t data_lim
 	DEBUG_TRACE("%p: init udp tracker\n", utii);
 
 	spin_lock_bh(&utii->lock);
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 	utii->data_limit = data_limit;
+#endif
 	if ((src_port < 1024) || (dest_port < 1024)) {
 		/*
 		 * Because UDP connections can be reaped we assign well known ports to the WKP timer group.
@@ -902,6 +931,9 @@ struct ecm_tracker_udp_instance *ecm_tracker_udp_alloc(void)
 
 	utii->udp_base.base.ref = ecm_tracker_udp_ref_callback;
 	utii->udp_base.base.deref = ecm_tracker_udp_deref_callback;
+	utii->udp_base.base.state_update = ecm_tracker_udp_state_update_callback;
+	utii->udp_base.base.state_get = ecm_tracker_udp_state_get_callback;
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 	utii->udp_base.base.datagram_count_get = ecm_tracker_udp_datagram_count_get_callback;
 	utii->udp_base.base.datagram_discard = ecm_tracker_udp_datagram_discard_callback;
 	utii->udp_base.base.datagram_read = ecm_tracker_udp_datagram_read_callback;
@@ -911,15 +943,14 @@ struct ecm_tracker_udp_instance *ecm_tracker_udp_alloc(void)
 	utii->udp_base.base.data_total_get = ecm_tracker_udp_data_total_get_callback;
 	utii->udp_base.base.data_limit_get = ecm_tracker_udp_data_limit_get_callback;
 	utii->udp_base.base.data_limit_set = ecm_tracker_udp_data_limit_set_callback;
-	utii->udp_base.base.state_update = ecm_tracker_udp_state_update_callback;
-	utii->udp_base.base.state_get = ecm_tracker_udp_state_get_callback;
-#ifdef ECM_STATE_OUTPUT_ENABLE
-	utii->udp_base.base.xml_state_get = ecm_tracker_udp_xml_state_get_callback;
-#endif
 
 	utii->udp_base.data_read = ecm_tracker_udp_data_read_callback;
 	utii->udp_base.data_size_get = ecm_tracker_udp_data_size_get_callback;
 	utii->udp_base.datagram_add = ecm_tracker_udp_datagram_add_checked_callback;
+#endif
+#ifdef ECM_STATE_OUTPUT_ENABLE
+	utii->udp_base.base.xml_state_get = ecm_tracker_udp_xml_state_get_callback;
+#endif
 
 	spin_lock_init(&utii->lock);
 
diff --git a/ecm_tracker_udp.h b/ecm_tracker_udp.h
index c14abb9..7d7595e 100644
--- a/ecm_tracker_udp.h
+++ b/ecm_tracker_udp.h
@@ -1,6 +1,6 @@
 /*
  **************************************************************************
- * Copyright (c) 2014, The Linux Foundation.  All rights reserved.
+ * Copyright (c) 2014, 2015, The Linux Foundation.  All rights reserved.
  * Permission to use, copy, modify, and/or distribute this software for
  * any purpose with or without fee is hereby granted, provided that the
  * above copyright notice and this permission notice appear in all copies.
@@ -16,19 +16,23 @@
 
 struct ecm_tracker_udp_instance;
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 typedef int32_t (*ecm_tracker_udp_data_size_get_method_t)(struct ecm_tracker_udp_instance *uti, ecm_tracker_sender_type_t sender, int32_t i);
 										/* Return size in bytes of datagram data at index i that was sent by the sender */
 typedef int (*ecm_tracker_udp_data_read_method_t)(struct ecm_tracker_udp_instance *uti, ecm_tracker_sender_type_t sender, int32_t i, int32_t offset, int32_t size, void *buffer);
 										/* Read size bytes of data at index i into the buffer */
 typedef bool (*ecm_tracker_udp_datagram_add_method_t)(struct ecm_tracker_udp_instance *uti, ecm_tracker_sender_type_t sender, struct ecm_tracker_ip_header *ip_hdr, struct ecm_tracker_ip_protocol_header *ecm_udp_header, struct udphdr *udp_header, struct sk_buff *skb);
 										/* Add a pre-checked UDP datagram */
+#endif
 
 struct ecm_tracker_udp_instance {
 	struct ecm_tracker_instance base;					/* MUST BE FIRST FIELD */
 
+#ifdef ECM_TRACKER_DPI_SUPPORT_ENABLE
 	ecm_tracker_udp_data_read_method_t data_read;				/* Read data from a UDP datagram (headers not considered) */
 	ecm_tracker_udp_data_size_get_method_t data_size_get;			/* Get data size of datagram (headers not considered) */
 	ecm_tracker_udp_datagram_add_method_t datagram_add;			/* Add a pre-checked UDP datagram */
+#endif
 };
 
 
-- 
1.8.2

